function [I1_d I2_d] = DownSampleTwo(I1,I2,DownsampleSize)

%Downsampling I1 and I2
%The larger one is downsampled to "DownsamplingSize*DownsamplingSize",
%another one would be downsampled accordingly (to (SizeofSmallOne/SizeofLargerOne)*DownsamplingSize)

[idy idx] = find(I1 == 0);
minx = min(idx);
maxx = max(idx);
miny = min(idy);
maxy = max(idy);
Size1 = max((maxx-minx),(maxy-miny));

[idy idx] = find(I2 == 0);
minx = min(idx);
maxx = max(idx);
miny = min(idy);
maxy = max(idy);
Size2 = max((maxx-minx),(maxy-miny));

if Size1>=Size2
    I1_d = normalize_img(I1,DownsampleSize);
    I2_d = normalize_img(I2,ceil((Size2/Size1)*DownsampleSize));
else
    I2_d = normalize_img(I1,ceil((Size1/Size2)*DownsampleSize));
    I1_d = normalize_img(I2,DownsampleSize);
end
