function pass_rate = Human_ThreeTrace(threshold)
% estimate the pass rate of humans using three traces for each control image

num_people = 4;
num_image = 143;
I = cell(num_people,num_image);
DownsampleSize = 30;

%Read in images 
for num_dir = 1:num_people
    D = uigetdir('','Choose one directory from Trace_human');
    flist=dir(D);
    fnum = length(flist);
    i = 1;
    j = 0;
    while i <= fnum
        if ~flist(i).isdir && ~strcmp(flist(i).name,'Thumbs.db')
            j = j + 1;
            name = flist(i).name;
            img = imread(sprintf('%s/%s',D,name));
            image_bw = im2bw(img,graythresh(img));
            I{num_dir,j} = image_bw;
        end
        i = i + 1;
    end
end


pass_num = 0;
for people_id1 = 1:num_people
    for img_id1 = 1:num_image %each one act as the trace for the 'control image'
        %compare to remaining three traces of the 'control image'
        img_id2 = img_id1;
        for people_id2 = 1:num_people
            if people_id2 ~= people_id1
                [I1 I2] = DownSampleTwo(I{people_id1,img_id1},I{people_id2,img_id2},DownsampleSize);
                dist = Dist(I1,I2)* Scale_Punish(I{people_id1,img_id1},I{people_id2,img_id2}) + DistanceCenterofMass(I{people_id1,img_id1},I{people_id2,img_id2},DownsampleSize);
                if dist <= threshold
                    pass_num = pass_num + 1;
                    break;
                end
            end
        end
    end
end

pass_rate = pass_num/(num_people*num_image);


