function pass_rate = Robot_ThreeTrace(threshold)
% estimate the pass rate of robots using three traces for each control image

num_people = 4;
num_image = 143;
I_inputs = cell(num_people,num_image);
I_dbs = cell(num_people,num_image);
DownsampleSize = 30;

%% Read in images to act as inputs from robots (in four folders)
for num_dir = 1:num_people
    D = uigetdir('','Choose one directory from Trace_robot');
    flist=dir(D);
    fnum = length(flist);
    i = 1;
    j = 0;
    while i <= fnum
        if ~flist(i).isdir && ~strcmp(flist(i).name,'Thumbs.db')
            j = j + 1;
            name = flist(i).name;
            img = imread(sprintf('%s/%s',D,name));
            image_bw = im2bw(img,graythresh(img));
            I_inputs{num_dir,j} = image_bw;
        end
        i = i + 1;
    end
end

%% Read in images to act as traces in our database (in four folders)
for num_dir = 1:num_people
    D = uigetdir('','Choose one directory from Trace_human');
    flist=dir(D);
    fnum = length(flist);
    i = 1;
    j = 0;
    while i <= fnum
        if ~flist(i).isdir && ~strcmp(flist(i).name,'Thumbs.db')
            j = j + 1;
            name = flist(i).name;
            img = imread(sprintf('%s/%s',D,name));
            image_bw = im2bw(img,graythresh(img));
            I_dbs{num_dir,j} = image_bw;
        end
        i = i + 1;
    end
end


pass_num = 0;
for people_id1 = 1:num_people
    for img_id1 = 1:num_image
        I_input = I_inputs{people_id1,img_id1}; %each trace will act as an input from the robot
        %each time compare to 3 traces (of same control image) from other people in our database
        for img_id2 = 1:num_image
            for people_id2 = 1:num_people
                if people_id2 ~= people_id1
                    I_db = I_dbs{people_id2,img_id2};
                    [I1 I2] = DownSampleTwo(I_input,I_db,DownsampleSize);
                    dist = Dist(I1,I2)* Scale_Punish(I_input,I_db) + DistanceCenterofMass(I_input,I_db,DownsampleSize);
                    if dist <= threshold
                        pass_num = pass_num + 1;
                        break;
                    end
                end
            end
        end
    end
end


pass_rate = pass_num/(num_people*num_image*num_image);


